﻿Imports System.Linq
Imports System
Imports System.Collections.Generic
Imports System.Linqs

Namespace CookieBinge2
	Public NotInheritable Class BingeService

        Public Shared Sub RecordBinge(ByVal count As Integer, ByVal worthIt As Boolean)
			Dim binge = New CookieBinge With {.HowMany = count, .WorthIt = worthIt, .TimeOccurred = Date.Now}

			Using context = New BingeContext()
				context.Binges.Add(binge)
				context.SaveChanges()
			End Using
		End Sub

        Public Shared Function GetRecentBinges(ByVal numberToRetrieve As Integer) As IEnumerable(Of CookieBinge)
            Using context = New BingeContext()
                Return context.Binges.OrderByDescending(Function(b) b.TimeOccurred).Take(numberToRetrieve).ToList()
            End Using
        End Function

        Public Shared Sub ClearHistory()
			Using context = New BingeContext()
				context.Database.EnsureDeleted()
				context.Database.EnsureCreated()
			End Using
		End Sub
	End Class
End Namespace