﻿Imports System.ComponentModel
Imports Windows.UI.Xaml

Namespace CookieBinge2
	Public Class BingeViewModel
		Implements INotifyPropertyChanged
		Public Delegate Sub BingeNotedHandler(ByVal sender As Object)

		Public Delegate Sub NomVisibleHandler(ByVal sender As Object)

		Private _clickCount As Integer
		Private _playing As Boolean
		Private _startControlsVisibility As Visibility = Visibility.Visible
		Private _stopControlsVisibility As Visibility = Visibility.Collapsed

        Public Property ClickCount As Integer
            Get
                Return _clickCount
            End Get

            Set(ByVal value As Integer)
                _clickCount = value
                OnPropertyChanged("ClickCount")
            End Set
        End Property

        Public Property StartControlsVisibility As Visibility
            Get
                Return _startControlsVisibility
            End Get

            Set(ByVal value As Visibility)
                _startControlsVisibility = value
                OnPropertyChanged("StartControlsVisibility")
            End Set
        End Property

        Public Property StopControlsVisibility As Visibility
            Get
                Return _stopControlsVisibility
            End Get
            Set(ByVal value As Visibility)
                _stopControlsVisibility = value
                OnPropertyChanged("StopControlsVisibility")
            End Set
        End Property

        Public Property Binging As Boolean
            Get
                Return _playing
            End Get
            Set(ByVal value As Boolean)
                _playing = value
                OnPropertyChanged("Playing")
            End Set
        End Property

        Public Event PropertyChanged As PropertyChangedEventHandler Implements INotifyPropertyChanged.PropertyChanged

		Public Event BingeCompleted As BingeNotedHandler

		Protected Sub OnPropertyChanged(ByVal [property] As String)
            RaiseEvent PropertyChanged(Me, New PropertyChangedEventArgs([property]))

        End Sub

		Protected Sub OnBingeCompleted()
           RaiseEvent BingeCompleted(Me)
        End Sub

		Friend Sub StoreBinge(ByVal worthIt As Boolean)
			BingeService.RecordBinge(_clickCount, worthIt)
			StartControlsVisibility = Visibility.Visible
			StopControlsVisibility = Visibility.Collapsed
			Binging = False
			OnBingeCompleted()
		End Sub

		Public Sub StartNewBinge()
			ClickCount = 0
			Binging = True
			StartControlsVisibility = Visibility.Collapsed
			StopControlsVisibility = Visibility.Visible
		End Sub

		Public Sub HandleClick()
			If Binging Then
				ClickCount += 1
			End If
		End Sub
	End Class
End Namespace