﻿Imports Windows.UI.Xaml
Imports Windows.UI.Xaml.Controls
Imports Windows.UI.Xaml.Input

Namespace CookieBinge2
	Public NotInheritable Partial Class MainPage
		Private ReadOnly _binge As BingeViewModel

		Public Sub New()
			InitializeComponent()
			'InitializeComponent(new Uri("ms-appx:///DeviceFamily-Mobile///MainPage.xaml", UriKind.Absolute));

			_binge = New BingeViewModel()
			NomText.Visibility = Visibility.Collapsed
			' Refresh bing list after a new binge is added
			AddHandler _binge.BingeCompleted, Sub(s) ReloadHistory()
			BingePane.DataContext = _binge
		End Sub

		Private Sub Page_Loaded(ByVal sender As Object, ByVal e As RoutedEventArgs)
			ReloadHistory()
		End Sub

		Private Sub ReloadHistory()
			BingeList.ItemsSource = BingeService.GetRecentBinges(5)
		End Sub

		'private void Image_Tapped(object sender, TappedRoutedEventArgs e) {
		'  _binge.HandleClick();
		'}

		Private Sub Play_Tapped(ByVal sender As Object, ByVal e As TappedRoutedEventArgs)
			_binge.StartNewBinge()
		End Sub


		Private Sub WorthIt_Click(ByVal sender As Object, ByVal e As RoutedEventArgs)
			_binge.StoreBinge(True)
		End Sub

		Private Sub NotWorthIt_Click(ByVal sender As Object, ByVal e As RoutedEventArgs)
			_binge.StoreBinge(False)
		End Sub

		Private Sub CookieImage_PointerPressed(ByVal sender As Object, ByVal e As PointerRoutedEventArgs)

			If _binge.Binging Then
				CType(sender, Image).CapturePointer(e.Pointer)

				Dim pt = e.GetCurrentPoint(BingeGrid)
				NomText.Margin = New Thickness(pt.Position.X, pt.Position.Y, 0, 0)

				NomText.Visibility = Visibility.Visible
				_binge.HandleClick()
				ReloadHistory()

			End If
		End Sub

		Private Sub CookieImage_PointerReleased(ByVal sender As Object, ByVal e As PointerRoutedEventArgs)
			CType(sender, Image).ReleasePointerCapture(e.Pointer)

			NomText.Visibility = Visibility.Collapsed
		End Sub

		Private Sub CookieImage_Tapped(ByVal sender As Object, ByVal e As TappedRoutedEventArgs)

		End Sub

		Private Sub ClearHistory_Click(ByVal sender As Object, ByVal e As RoutedEventArgs)
			BingeService.ClearHistory()
			ReloadHistory()
		End Sub
	End Class

End Namespace